## prometheus-node-exporter 0.10.0+ds

=== Makefile ===
# Copyright 2015 The Prometheus Authors
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
# http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

VERSION  := 0.10.0
TARGET   := node_exporter
GOFLAGS  := -ldflags "-X main.Version $(VERSION)"

include Makefile.COMMON

=== debian/changelog ===
prometheus-node-exporter (0.10.0+ds-3) unstable; urgency=medium

  * debian/postrm: Do remove log and pid files.
  * debian/init: Fix description.

 -- Martín Ferrari <tincho@debian.org>  Tue, 07 Jul 2015 11:28:12 +0000

prometheus-node-exporter (0.10.0+ds-2) unstable; urgency=medium

  * debian/control: Update dependency name for prometheus/log.
  * debian/postrm: Do not remove directories forcefully, as these are shared
    with other prometheus tools.

 -- Martín Ferrari <tincho@debian.org>  Tue, 07 Jul 2015 07:30:20 +0000

prometheus-node-exporter (0.10.0+ds-1) unstable; urgency=medium

  * Initial release. (Closes: #790748)
  * The source has been repackaged to include two dependencies that do not
    deserve separate packages at this time: github.com/beevik/ntp and
    github.com/soundcloud/go-runit.

 -- Martín Ferrari <tincho@debian.org>  Mon, 06 Jul 2015 18:22:37 +0000

## prometheus-node-exporter 0.11.0%2Bds

=== debian/control ===
Source: prometheus-node-exporter
Section: net
Priority: extra
Maintainer: Debian Go Packaging Team <pkg-go-maintainers@lists.alioth.debian.org>
Uploaders: Martín Ferrari <tincho@debian.org>
Build-Depends: debhelper (>= 9.0.0), dh-golang, golang-go,
 golang-github-prometheus-log-dev,
 golang-goprotobuf-dev,
 golang-procfs-dev (>= 0+git20150616),
 golang-prometheus-client-dev,
Standards-Version: 3.9.6
Vcs-Git: git://anonscm.debian.org/pkg-go/packages/prometheus-node-exporter.git
Vcs-Browser: http://anonscm.debian.org/cgit/pkg-go/packages/prometheus-node-exporter.git/
Homepage: https://github.com/prometheus/node_exporter

Package: prometheus-node-exporter
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, daemon
Built-Using: ${misc:Built-Using}
Description: Prometheus exporter for machine metrics
 Prometheus exporter for machine metrics, written in Go with pluggable metric
 collectors.

## prometheus-node-exporter 0.11.0+ds

=== Makefile ===
--- 
+++ 
@@ -11,7 +11,7 @@
 # See the License for the specific language governing permissions and
 # limitations under the License.
 
-VERSION  := 0.10.0
+VERSION  := 0.11.0
 TARGET   := node_exporter
 GOFLAGS  := -ldflags "-X main.Version $(VERSION)"

=== debian/changelog ===
prometheus-node-exporter (0.11.0+ds-1) unstable; urgency=medium

  * New upstream release.

 -- Martín Ferrari <tincho@debian.org>  Thu, 03 Sep 2015 15:35:33 +0300

=== debian/rules ===
#!/usr/bin/make -f

export DH_VERBOSE=1
export DH_GOPKG := github.com/prometheus/node_exporter

DEBVERS    ?= $(shell dpkg-parsechangelog | sed -n -e 's/^Version: //p')
VERSION    ?= $(shell echo '$(DEBVERS)' | sed 's/^[[:digit:]]*://; s/[-].*//')
DEBPKGNAME ?= $(shell dpkg-parsechangelog | sed -n -e 's/^Source: //p')
BUILDDIR := $(shell perl -w -MDebian::Debhelper::Buildsystem::golang -e \
        'print Debian::Debhelper::Buildsystem::golang->new()->get_builddir()')

%:
	dh $@ --buildsystem=golang --with=golang

override_dh_auto_configure:
	dh_auto_configure -O--buildsystem=golang
	# Include vendored dependencies.
	for i in github.com/beevik/ntp github.com/soundcloud/go-runit; do \
            DEST=`dirname $(BUILDDIR)/src/$(DH_GOPKG)/deps/$$i`; \
	    mkdir -p $$DEST; \
	    cp -av deps/$$i $$DEST; \
	done
	# Copy test fixtures.
	cp -av collector/fixtures $(BUILDDIR)/src/$(DH_GOPKG)/collector

override_dh_auto_build:
	dh_auto_build -O--buildsystem=golang -- $(BUILDFLAGS)

override_dh_auto_install:
	dh_auto_install
	# we don't want the golang source (yet?)
	rm -r debian/$(DEBPKGNAME)/usr/share/gocode
	# Rename the binary to match the debian package.
	mv -v debian/$(DEBPKGNAME)/usr/bin/node_exporter \
            debian/$(DEBPKGNAME)/usr/bin/$(DEBPKGNAME)

gen-orig-tgz:
	if [ ! -f ../$(DEBPKGNAME)_$(VERSION).orig.tar.gz ] ; then \
	    git-archive-all --format tar \
                --prefix $(DEBPKGNAME)-$(VERSION)/ -t upstream/$(VERSION) \
                -- - | gzip > ../$(DEBPKGNAME)_$(VERSION).orig.tar.gz ; \
	fi

=== debian/watch ===
version=3

opts="filenamemangle=s/(?:.*\/)?v?(\d[\d\.]*)\.tar\.gz/prometheus-node-exporter-$1.tar.gz/,dversionmangle=s/\+ds\d*$//" \
         https://github.com/prometheus/node_exporter/tags \
         (?:.*/)?v?(\d[\d\.]*)\.tar\.gz

## prometheus-node-exporter 0.12.0+ds+really0.12.0

=== debian/changelog ===
prometheus-node-exporter (0.12.0+ds+really0.12.0-2) unstable; urgency=medium

  * debian/watch: Take into account RCs and current version hack.
  * debian/control: Update dependencies and Vcs-* links.
  * debian/rules: Simplify with new dh_golang features; add version info.
  * Fix default configuration.
  * Add systemd service file.
  * Add logrotate script.
  * Enable the textfile collector by default.
  * Remove rotated logs and textfile directory on purge.

 -- Martín Ferrari <tincho@debian.org>  Thu, 30 Jun 2016 13:30:21 +0000

prometheus-node-exporter (0.12.0+ds+really0.12.0-1) unstable; urgency=medium

  * New upstream release, which is really 0.12.0. The previous version was
    actually 0.12.0rc1, but I made a mistake, hence the weird version number
    for this release. Closes: #814227.
  * Stop ignoring some configuration values in initscript. Thanks to
    contaminates@baconmail.net for the patch. Closes: #813544.
  * Remove now unneeded patches.
  * debian/control:
    - Add new dependencies.
    - Update Standards-Version with no changes.
  * debian/rules: Fix gen-orig-tgz target.

 -- Martín Ferrari <tincho@debian.org>  Fri, 06 May 2016 19:02:38 +0000

prometheus-node-exporter (0.12.0+ds-2) unstable; urgency=medium

  * Fix builds on arm64.

 -- Martín Ferrari <tincho@debian.org>  Mon, 25 Jan 2016 16:58:35 -0300

prometheus-node-exporter (0.12.0+ds-1) unstable; urgency=medium

  * New upstream release.
  * Add new dependency on golang-github-kolo-xmlrpc-dev.
  * Add new dependency on golang-github-prometheus-common-dev, and update
    patches.

 -- Martín Ferrari <tincho@debian.org>  Mon, 11 Jan 2016 19:29:42 +0000

=== debian/control ===
--- 
+++ 
@@ -3,13 +3,18 @@
 Priority: extra
 Maintainer: Debian Go Packaging Team <pkg-go-maintainers@lists.alioth.debian.org>
 Uploaders: Martín Ferrari <tincho@debian.org>
-Build-Depends: debhelper (>= 9.0.0), dh-golang, golang-go,
- golang-github-prometheus-log-dev,
+Build-Depends: debhelper (>= 9.0.0), dh-golang (>= 1.17~), golang-any (>= 1.5~),
+ golang-dbus-dev,
+ golang-github-coreos-go-systemd-dev,
+ golang-github-kolo-xmlrpc-dev,
+ golang-github-prometheus-client-model-dev,
+ golang-github-prometheus-common-dev (>= 0+git20160504),
+ golang-golang-x-sys-dev,
  golang-goprotobuf-dev,
  golang-procfs-dev (>= 0+git20150616),
- golang-prometheus-client-dev,
-Standards-Version: 3.9.6
-Vcs-Git: git://anonscm.debian.org/pkg-go/packages/prometheus-node-exporter.git
+ golang-prometheus-client-dev (>= 0.7.0+ds-3),
+Standards-Version: 3.9.8
+Vcs-Git: http://anonscm.debian.org/git/pkg-go/packages/prometheus-node-exporter.git/
 Vcs-Browser: http://anonscm.debian.org/cgit/pkg-go/packages/prometheus-node-exporter.git/
 Homepage: https://github.com/prometheus/node_exporter

=== debian/rules ===
#!/usr/bin/make -f

export DH_VERBOSE=1
export DH_GOPKG := github.com/prometheus/node_exporter
export DH_GOLANG_INSTALL_EXTRA := collector/fixtures

BUILDDIR := $(CURDIR)/build
METAPKG := github.com/prometheus/common

DEBVERS    ?= $(shell dpkg-parsechangelog -SVersion)
VERSION    ?= $(shell echo '$(DEBVERS)' | sed 's/^[[:digit:]]*://; s/[-].*//')
DEBPKGNAME ?= $(shell dpkg-parsechangelog -SSource)
DEBDATE    ?= $(shell dpkg-parsechangelog -SDate)
REV        := $(DEBVERS)
BRANCH     := debian/sid
USER       := pkg-go-maintainers@lists.alioth.debian.org
HOSTNAME   := debian
BUILD_DATE := $(shell date --utc --date='$(DEBDATE)' +%Y%m%d-%H:%M:%S)
GO_VERSION := $(shell go version | sed 's/go version \(\S*\).*/\1/')
BUILDFLAGS := -ldflags \
  " -X $(METAPKG)/version.Version=$(VERSION)\
    -X $(METAPKG)/version.Revision=$(REV)\
    -X $(METAPKG)/version.Branch=$(BRANCH)\
    -X $(METAPKG)/version.BuildUser=$(USER)\
    -X $(METAPKG)/version.BuildDate=$(BUILD_DATE)\
    -X $(METAPKG)/version.GoVersion=$(GO_VERSION)"

%:
	dh $@ --buildsystem=golang --with=golang --builddirectory=$(BUILDDIR)

override_dh_auto_build:
	dh_auto_build -- $(BUILDFLAGS)

override_dh_auto_test:
	chmod a+x $(BUILDDIR)/src/$(DH_GOPKG)/collector/fixtures/megacli
	dh_auto_test

override_dh_auto_install:
	mkdir -p debian/$(DEBPKGNAME)/usr/bin
	# Rename the binary to match the debian package.
	cp -v $(BUILDDIR)/bin/node_exporter \
            debian/$(DEBPKGNAME)/usr/bin/$(DEBPKGNAME)
	cp -v debian/README.textfile \
            debian/$(DEBPKGNAME)/var/lib/prometheus/node-exporter

gen-orig-tgz:
	if [ ! -f ../$(DEBPKGNAME)_$(VERSION).orig.tar.gz ] ; then \
            git archive --format=tar.gz --prefix=$(DEBPKGNAME)-$(VERSION)/ \
            upstream/$(VERSION) >../$(DEBPKGNAME)_$(VERSION).orig.tar.gz ; \
	fi

=== debian/watch ===
version=3

opts="filenamemangle=s/(?:.*\/)?v?(\d[\d\.]*)\.tar\.gz/prometheus-node-exporter-$1.tar.gz/,dversionmangle=s/\+ds.*$//,uversionmangle=s/(rc\d+)/~$1/" \
         https://github.com/prometheus/node_exporter/tags \
         (?:.*/)?v?(\d[\d\.]*(?:rc\d+)?)\.tar\.gz

## prometheus-node-exporter 0.13.0+ds

=== Makefile ===
--- 
+++ 
@@ -11,8 +11,50 @@
 # See the License for the specific language governing permissions and
 # limitations under the License.
 
-VERSION  := 0.11.0
-TARGET   := node_exporter
-GOFLAGS  := -ldflags "-X main.Version $(VERSION)"
+GO    := GO15VENDOREXPERIMENT=1 go
+PROMU := $(GOPATH)/bin/promu
+pkgs   = $(shell $(GO) list ./... | grep -v /vendor/)
 
-include Makefile.COMMON
+PREFIX                  ?= $(shell pwd)
+BIN_DIR                 ?= $(shell pwd)
+DOCKER_IMAGE_NAME       ?= node-exporter
+DOCKER_IMAGE_TAG        ?= $(subst /,-,$(shell git rev-parse --abbrev-ref HEAD))
+
+
+all: format build test
+
+style:
+	@echo ">> checking code style"
+	@! gofmt -d $(shell find . -path ./vendor -prune -o -name '*.go' -print) | grep '^'
+
+test:
+	@echo ">> running tests"
+	@$(GO) test -short $(pkgs)
+
+format:
+	@echo ">> formatting code"
+	@$(GO) fmt $(pkgs)
+
+vet:
+	@echo ">> vetting code"
+	@$(GO) vet $(pkgs)
+
+build: promu
+	@echo ">> building binaries"
+	@$(PROMU) build --prefix $(PREFIX)
+
+tarball: promu
+	@echo ">> building release tarball"
+	@$(PROMU) tarball --prefix $(PREFIX) $(BIN_DIR)
+
+docker:
+	@echo ">> building docker image"
+	@docker build -t "$(DOCKER_IMAGE_NAME):$(DOCKER_IMAGE_TAG)" .
+
+promu:
+	@GOOS=$(shell uname -s | tr A-Z a-z) \
+		GOARCH=$(subst x86_64,amd64,$(patsubst i%86,386,$(shell uname -m))) \
+		$(GO) get -u github.com/prometheus/promu
+
+
+.PHONY: all style format build test vet tarball docker promu

=== debian/changelog ===
prometheus-node-exporter (0.13.0+ds-1) unstable; urgency=medium

  * New upstream release.
  * Work around gccgo inability to handle vendor directory.
  * Fix build for arches not contemplated upstream.

 -- Martín Ferrari <tincho@debian.org>  Sat, 14 Jan 2017 05:38:44 -0300

prometheus-node-exporter (0.13.0~rc.2+ds-1) unstable; urgency=medium

  [ Paul Tagliamonte ]
  * Team upload.
  * Use a secure transport for the Vcs-Git and Vcs-Browser URL

  [ Martín Ferrari ]
  * Actually use https for Vcs-Browser.
  * Filter out /(sys|proc|dev|run) filesystems by default.
  * debian/default: Add escapes in multiline variable. Closes: #840947.
  * debian/watch: Update with latest upstream versioning fmt.
  * New upstream release.
  * Update available parameters.

 -- Martín Ferrari <tincho@debian.org>  Sat, 19 Nov 2016 17:28:35 +0000

=== debian/control ===
--- 
+++ 
@@ -14,8 +14,8 @@
  golang-procfs-dev (>= 0+git20150616),
  golang-prometheus-client-dev (>= 0.7.0+ds-3),
 Standards-Version: 3.9.8
-Vcs-Git: http://anonscm.debian.org/git/pkg-go/packages/prometheus-node-exporter.git/
-Vcs-Browser: http://anonscm.debian.org/cgit/pkg-go/packages/prometheus-node-exporter.git/
+Vcs-Git: https://anonscm.debian.org/git/pkg-go/packages/prometheus-node-exporter.git
+Vcs-Browser: https://anonscm.debian.org/cgit/pkg-go/packages/prometheus-node-exporter.git/
 Homepage: https://github.com/prometheus/node_exporter
 
 Package: prometheus-node-exporter

=== debian/rules ===
--- 
+++ 
@@ -17,6 +17,7 @@
 HOSTNAME   := debian
 BUILD_DATE := $(shell date --utc --date='$(DEBDATE)' +%Y%m%d-%H:%M:%S)
 GO_VERSION := $(shell go version | sed 's/go version \(\S*\).*/\1/')
+GCCGO      := $(strip $(shell go version | grep gccgo))
 BUILDFLAGS := -ldflags \
   " -X $(METAPKG)/version.Version=$(VERSION)\
     -X $(METAPKG)/version.Revision=$(REV)\
@@ -27,6 +28,19 @@
 
 %:
 	dh $@ --buildsystem=golang --with=golang --builddirectory=$(BUILDDIR)
+
+ifneq ($(GCCGO),)
+# Gccgo ignores vendoring.
+override_dh_auto_configure:
+	dh_auto_configure
+	for i in github.com/beevik github.com/soundcloud; \
+        do \
+            src=$(BUILDDIR)/src/$(DH_GOPKG)/vendor/$$i; \
+            dst=`dirname $(BUILDDIR)/src/$$i`; \
+            mkdir -vp $$dst; \
+            mv -v $$src $$dst; \
+        done
+endif
 
 override_dh_auto_build:
 	dh_auto_build -- $(BUILDFLAGS)

## prometheus-node-exporter 0.14.0%2Bds

=== debian/control ===
Source: prometheus-node-exporter
Section: net
Priority: extra
Maintainer: Debian Go Packaging Team <pkg-go-maintainers@lists.alioth.debian.org>
Uploaders: Martín Ferrari <tincho@debian.org>
Build-Depends: debhelper (>= 9.20160709),
               dh-golang (>= 1.17~),
               golang-any (>= 1.5~),
               golang-dbus-dev,
               golang-github-coreos-go-systemd-dev,
               golang-github-kolo-xmlrpc-dev,
               golang-github-prometheus-client-model-dev,
               golang-github-prometheus-common-dev (>= 0+git20160504),
               golang-golang-x-sys-dev (>= 0.0~git20170630),
               golang-goprotobuf-dev,
               golang-procfs-dev (>= 0+git20170703),
               golang-prometheus-client-dev (>= 0.7.0+ds-3),
Standards-Version: 4.0.0
Vcs-Git: https://anonscm.debian.org/git/pkg-go/packages/prometheus-node-exporter.git
Vcs-Browser: https://anonscm.debian.org/cgit/pkg-go/packages/prometheus-node-exporter.git
Homepage: https://github.com/prometheus/node_exporter
Testsuite: autopkgtest-pkg-go

Package: prometheus-node-exporter
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends},
         daemon | systemd-sysv,
Built-Using: ${misc:Built-Using}
Description: Prometheus exporter for machine metrics
 Prometheus exporter for machine metrics, written in Go with pluggable metric
 collectors.

## prometheus-node-exporter 0.14.0+ds

=== Makefile ===
--- 
+++ 
@@ -11,17 +11,31 @@
 # See the License for the specific language governing permissions and
 # limitations under the License.
 
-GO    := GO15VENDOREXPERIMENT=1 go
-PROMU := $(GOPATH)/bin/promu
-pkgs   = $(shell $(GO) list ./... | grep -v /vendor/)
+GO     ?= GO15VENDOREXPERIMENT=1 go
+GOPATH := $(firstword $(subst :, ,$(GOPATH)))
+
+PROMU       ?= $(GOPATH)/bin/promu
+STATICCHECK ?= $(GOPATH)/bin/staticcheck
+pkgs         = $(shell $(GO) list ./... | grep -v /vendor/)
 
 PREFIX                  ?= $(shell pwd)
 BIN_DIR                 ?= $(shell pwd)
 DOCKER_IMAGE_NAME       ?= node-exporter
 DOCKER_IMAGE_TAG        ?= $(subst /,-,$(shell git rev-parse --abbrev-ref HEAD))
 
+ifeq ($(OS),Windows_NT)
+    OS_detected := Windows
+else
+    OS_detected := $(shell uname -s)
+endif
 
-all: format build test
+ifeq ($(OS_detected), Linux)
+    test-e2e := test-e2e
+else
+    test-e2e := skip-test-e2e
+endif
+
+all: format vet staticcheck build test $(test-e2e)
 
 style:
 	@echo ">> checking code style"
@@ -31,6 +45,13 @@
 	@echo ">> running tests"
 	@$(GO) test -short $(pkgs)
 
+test-e2e: build
+	@echo ">> running end-to-end tests"
+	./end-to-end-test.sh
+
+skip-test-e2e:
+	@echo ">> SKIP running end-to-end tests on $(OS_detected)"
+
 format:
 	@echo ">> formatting code"
 	@$(GO) fmt $(pkgs)
@@ -39,11 +60,15 @@
 	@echo ">> vetting code"
 	@$(GO) vet $(pkgs)
 
-build: promu
+staticcheck: $(STATICCHECK)
+	@echo ">> running staticcheck"
+	@$(STATICCHECK) $(pkgs)
+
+build: $(PROMU)
 	@echo ">> building binaries"
 	@$(PROMU) build --prefix $(PREFIX)
 
-tarball: promu
+tarball: $(PROMU)
 	@echo ">> building release tarball"
 	@$(PROMU) tarball --prefix $(PREFIX) $(BIN_DIR)
 
@@ -51,10 +76,11 @@
 	@echo ">> building docker image"
 	@docker build -t "$(DOCKER_IMAGE_NAME):$(DOCKER_IMAGE_TAG)" .
 
-promu:
-	@GOOS=$(shell uname -s | tr A-Z a-z) \
-		GOARCH=$(subst x86_64,amd64,$(patsubst i%86,386,$(shell uname -m))) \
-		$(GO) get -u github.com/prometheus/promu
+$(GOPATH)/bin/promu promu:
+	@GOOS= GOARCH= $(GO) get -u github.com/prometheus/promu
+
+$(GOPATH)/bin/staticcheck:
+	@GOOS= GOARCH= $(GO) get -u honnef.co/go/tools/cmd/staticcheck
 
 
-.PHONY: all style format build test vet tarball docker promu
+.PHONY: all style format build test test-e2e vet tarball docker promu staticcheck

=== debian/changelog ===
prometheus-node-exporter (0.14.0+ds-3) unstable; urgency=medium

  * Fix problem introduced by the combination of two flags (nozfs and mips*).
  * Fix test timing issue in slow arches.

 -- Martín Ferrari <tincho@debian.org>  Sat, 19 Aug 2017 11:34:09 +0000

prometheus-node-exporter (0.14.0+ds-2) unstable; urgency=medium

  * Add dh-systemd support. Closes: #866399.
  * Only depend on daemon if systemd-sysv is not installed. Closes: #870083.
  * Fix compilation on gccgo/mips*.
  * Fix integration test (wrong path under gccgo).
  * Disable the ZFS collector in 32-bit arches, until issue #629 is
    solved upstream.

 -- Martín Ferrari <tincho@debian.org>  Fri, 18 Aug 2017 09:36:40 +0000

prometheus-node-exporter (0.14.0+ds-1) unstable; urgency=medium

  * New upstream version. Closes: #867908.
  * Updated debian/copyright for vendored dependencies.
  * Add missing tests.
  * Update documentation, defaults file, examples.
  * debian/control: Update Standards-Version (no changes).
  * debian/control: Fix Vcs-* fields.
  * debian/control: Mark package as autopkgtest-able.
  * debian/control: Update dependency on procfs.
  * debian/gbp.conf: Add builder defaults.

 -- Martín Ferrari <tincho@debian.org>  Wed, 12 Jul 2017 00:54:52 +0000

=== debian/control ===
--- 
+++ 
@@ -3,15 +3,16 @@
 Priority: extra
 Maintainer: Debian Go Packaging Team <pkg-go-maintainers@lists.alioth.debian.org>
 Uploaders: Martín Ferrari <tincho@debian.org>
-Build-Depends: debhelper (>= 9.20160709),
+Build-Depends: debhelper (>= 9.0.0),
                dh-golang (>= 1.17~),
+               dh-systemd,
                golang-any (>= 1.5~),
                golang-dbus-dev,
                golang-github-coreos-go-systemd-dev,
                golang-github-kolo-xmlrpc-dev,
                golang-github-prometheus-client-model-dev,
                golang-github-prometheus-common-dev (>= 0+git20160504),
-               golang-golang-x-sys-dev (>= 0.0~git20170630),
+               golang-golang-x-sys-dev,
                golang-goprotobuf-dev,
                golang-procfs-dev (>= 0+git20170703),
                golang-prometheus-client-dev (>= 0.7.0+ds-3),

=== debian/rules ===
--- 
+++ 
@@ -18,7 +18,8 @@
 BUILD_DATE := $(shell date --utc --date='$(DEBDATE)' +%Y%m%d-%H:%M:%S)
 GO_VERSION := $(shell go version | sed 's/go version \(\S*\).*/\1/')
 GCCGO      := $(strip $(shell go version | grep gccgo))
-BUILDFLAGS := -ldflags \
+BUILDTAGS  :=
+BUILDFLAGS  = -tags "$(BUILDTAGS)" -ldflags \
   " -X $(METAPKG)/version.Version=$(VERSION)\
     -X $(METAPKG)/version.Revision=$(REV)\
     -X $(METAPKG)/version.Branch=$(BRANCH)\
@@ -27,9 +28,18 @@
     -X $(METAPKG)/version.GoVersion=$(GO_VERSION)"
 
 %:
-	dh $@ --buildsystem=golang --with=golang --builddirectory=$(BUILDDIR)
+	dh $@ --buildsystem=golang --with=golang,systemd \
+            --builddirectory=$(BUILDDIR)
+
+DEB_HOST_ARCH := $(shell dpkg-architecture -qDEB_HOST_ARCH)
+DEB_HOST_ARCH_BITS := $(shell dpkg-architecture -qDEB_HOST_ARCH_BITS)
 
 ifneq ($(GCCGO),)
+# Workaround until #872402 is fixed.
+ifeq ($(findstring mips,$(DEB_HOST_ARCH)),mips)
+# mipsel => mipsle, mips64el => mips64le
+BUILDTAGS += $(DEB_HOST_ARCH:el=le)
+endif
 # Gccgo ignores vendoring.
 override_dh_auto_configure:
 	dh_auto_configure
@@ -42,12 +52,17 @@
         done
 endif
 
+# ZFS (or its tests) are not working in 32-bit arches.
+ifeq ($(DEB_HOST_ARCH_BITS),32)
+BUILDTAGS += nozfs
+endif
+
 override_dh_auto_build:
 	dh_auto_build -- $(BUILDFLAGS)
 
 override_dh_auto_test:
 	chmod a+x $(BUILDDIR)/src/$(DH_GOPKG)/collector/fixtures/megacli
-	dh_auto_test
+	dh_auto_test -- $(BUILDFLAGS)
 
 override_dh_auto_install:
 	mkdir -p debian/$(DEBPKGNAME)/usr/bin
@@ -56,9 +71,3 @@
             debian/$(DEBPKGNAME)/usr/bin/$(DEBPKGNAME)
 	cp -v debian/README.textfile \
             debian/$(DEBPKGNAME)/var/lib/prometheus/node-exporter
-
-gen-orig-tgz:
-	if [ ! -f ../$(DEBPKGNAME)_$(VERSION).orig.tar.gz ] ; then \
-            git archive --format=tar.gz --prefix=$(DEBPKGNAME)-$(VERSION)/ \
-            upstream/$(VERSION) >../$(DEBPKGNAME)_$(VERSION).orig.tar.gz ; \
-	fi

## prometheus-node-exporter 0.15.2%2Bds

=== Makefile ===
--- 
+++ 
@@ -12,7 +12,9 @@
 # limitations under the License.
 
 GO     ?= GO15VENDOREXPERIMENT=1 go
-GOPATH := $(firstword $(subst :, ,$(GOPATH)))
+GOPATH := $(firstword $(subst :, ,$(shell $(GO) env GOPATH)))
+GOARCH := $(shell $(GO) env GOARCH)
+GOHOSTARCH := $(shell $(GO) env GOHOSTARCH)
 
 PROMU       ?= $(GOPATH)/bin/promu
 STATICCHECK ?= $(GOPATH)/bin/staticcheck
@@ -22,6 +24,13 @@
 BIN_DIR                 ?= $(shell pwd)
 DOCKER_IMAGE_NAME       ?= node-exporter
 DOCKER_IMAGE_TAG        ?= $(subst /,-,$(shell git rev-parse --abbrev-ref HEAD))
+MACH                    ?= $(shell uname -m)
+DOCKERFILE              ?= Dockerfile
+
+ifeq ($(GOHOSTARCH),amd64)
+	# Only supported on amd64
+	test-flags := -race
+endif
 
 ifeq ($(OS),Windows_NT)
     OS_detected := Windows
@@ -35,17 +44,45 @@
     test-e2e := skip-test-e2e
 endif
 
-all: format vet staticcheck build test $(test-e2e)
+# 64bit -> 32bit mapping for cross-checking. At least for amd64/386, the 64bit CPU can execute 32bit code but not the other way around, so we don't support cross-testing upwards.
+cross-test = skip-test-32bit
+define goarch_pair
+	ifeq ($$(OS_detected),Linux)
+		ifeq ($$(GOARCH),$1)
+			GOARCH_CROSS = $2
+			cross-test = test-32bit
+		endif
+	endif
+endef
+
+# By default, "cross" test with ourselves to cover unknown pairings.
+$(eval $(call goarch_pair,amd64,386))
+$(eval $(call goarch_pair,arm64,arm))
+$(eval $(call goarch_pair,mips64,mips))
+$(eval $(call goarch_pair,mips64el,mipsel))
+
+all: format vet staticcheck build test $(cross-test) $(test-e2e)
 
 style:
 	@echo ">> checking code style"
 	@! gofmt -d $(shell find . -path ./vendor -prune -o -name '*.go' -print) | grep '^'
 
-test:
+test: collector/fixtures/sys/.unpacked
 	@echo ">> running tests"
-	@$(GO) test -short $(pkgs)
+	$(GO) test -short $(test-flags) $(pkgs)
 
-test-e2e: build
+test-32bit: collector/fixtures/sys/.unpacked
+	@echo ">> running tests in 32-bit mode"
+	@env GOARCH=$(GOARCH_CROSS) $(GO) test $(pkgs)
+
+skip-test-32bit:
+	@echo ">> SKIP running tests in 32-bit mode: not supported on $(OS_detected)/$(GOARCH)"
+
+collector/fixtures/sys/.unpacked: collector/fixtures/sys.ttar
+	./ttar -C collector/fixtures -x -f collector/fixtures/sys.ttar
+	touch $@
+
+test-e2e: build collector/fixtures/sys/.unpacked
 	@echo ">> running end-to-end tests"
 	./end-to-end-test.sh
 
@@ -73,8 +110,15 @@
 	@$(PROMU) tarball --prefix $(PREFIX) $(BIN_DIR)
 
 docker:
-	@echo ">> building docker image"
-	@docker build -t "$(DOCKER_IMAGE_NAME):$(DOCKER_IMAGE_TAG)" .
+ifeq ($(MACH), ppc64le)
+	$(eval DOCKERFILE=Dockerfile.ppc64le)
+endif
+	@echo ">> building docker image from $(DOCKERFILE)"
+	@docker build --file $(DOCKERFILE) -t "$(DOCKER_IMAGE_NAME):$(DOCKER_IMAGE_TAG)" .
+
+test-docker:
+	@echo ">> testing docker image"
+	./test_image.sh "$(DOCKER_IMAGE_NAME):$(DOCKER_IMAGE_TAG)" 9100
 
 $(GOPATH)/bin/promu promu:
 	@GOOS= GOARCH= $(GO) get -u github.com/prometheus/promu
@@ -84,3 +128,9 @@
 
 
 .PHONY: all style format build test test-e2e vet tarball docker promu staticcheck
+
+# Declaring the binaries at their default locations as PHONY targets is a hack
+# to ensure the latest version is downloaded on every make execution.
+# If this is not desired, copy/symlink these binaries to a different path and
+# set the respective environment variables.
+.PHONY: $(GOPATH)/bin/promu $(GOPATH)/bin/staticcheck

=== debian/control ===
Source: prometheus-node-exporter
Maintainer: Debian Go Packaging Team <pkg-go-maintainers@lists.alioth.debian.org>
Uploaders: Martín Ferrari <tincho@debian.org>,
Section: net
Testsuite: autopkgtest-pkg-go
Priority: optional
Build-Depends: debhelper (>= 10),
               dh-golang (>= 1.17~),
               golang-any,
               golang-dbus-dev,
               golang-github-coreos-go-systemd-dev,
               golang-github-kolo-xmlrpc-dev,
               golang-github-prometheus-client-golang-dev,
               golang-github-prometheus-client-model-dev,
               golang-github-prometheus-common-dev (>= 0+git20171117),
               golang-golang-x-sys-dev,
               golang-gopkg-alecthomas-kingpin.v2-dev,
               golang-goprotobuf-dev,
               golang-procfs-dev (>= 0+git20170703),
Standards-Version: 4.1.2
Vcs-Browser: https://anonscm.debian.org/cgit/pkg-go/packages/prometheus-node-exporter.git
Vcs-Git: https://anonscm.debian.org/git/pkg-go/packages/prometheus-node-exporter.git
Homepage: https://github.com/prometheus/node_exporter
XS-Go-Import-Path: github.com/prometheus/node_exporter

Package: prometheus-node-exporter
Architecture: any
Depends: daemon | systemd-sysv,
         ${misc:Depends},
         ${shlibs:Depends},
Built-Using: ${misc:Built-Using},
Description: Prometheus exporter for machine metrics
 Prometheus exporter for machine metrics, written in Go with pluggable metric
 collectors.

## prometheus-node-exporter 0.15.2+ds

=== debian/changelog ===
prometheus-node-exporter (0.15.2+ds-1) unstable; urgency=medium

  * New upstream release.
  * debian/control: Update package name for client-golang.
  * debian/control: Add XS-Go-Import-Path.
  * debian/control: Add/update dependencies, update Standards-Version,
    Priority and compat.
  * Replace dpkg-parsechangelog with /usr/share/dpkg/pkg-info.mk
  * Update defaults file.
  * Update debian/copyright.
  * Add debian/NEWS to warn of breaking changes.
  * Refresh patches.
  * Stop using pristine-tar.
  * Remove unused lintian overrides.

 -- Martín Ferrari <tincho@debian.org>  Thu, 14 Dec 2017 15:26:08 +0000

=== debian/rules ===
--- 
+++ 
@@ -1,4 +1,5 @@
 #!/usr/bin/make -f
+include /usr/share/dpkg/pkg-info.mk
 
 export DH_VERBOSE=1
 export DH_GOPKG := github.com/prometheus/node_exporter
@@ -7,21 +8,16 @@
 BUILDDIR := $(CURDIR)/build
 METAPKG := github.com/prometheus/common
 
-DEBVERS    ?= $(shell dpkg-parsechangelog -SVersion)
-VERSION    ?= $(shell echo '$(DEBVERS)' | sed 's/^[[:digit:]]*://; s/[-].*//')
-DEBPKGNAME ?= $(shell dpkg-parsechangelog -SSource)
-DEBDATE    ?= $(shell dpkg-parsechangelog -SDate)
-REV        := $(DEBVERS)
 BRANCH     := debian/sid
 USER       := pkg-go-maintainers@lists.alioth.debian.org
-HOSTNAME   := debian
-BUILD_DATE := $(shell date --utc --date='$(DEBDATE)' +%Y%m%d-%H:%M:%S)
+BUILD_DATE := $(shell date --utc --date='@$(SOURCE_DATE_EPOCH)' \
+    +%Y%m%d-%H:%M:%S)
 GO_VERSION := $(shell go version | sed 's/go version \(\S*\).*/\1/')
 GCCGO      := $(strip $(shell go version | grep gccgo))
 BUILDTAGS  :=
 BUILDFLAGS  = -tags "$(BUILDTAGS)" -ldflags \
-  " -X $(METAPKG)/version.Version=$(VERSION)\
-    -X $(METAPKG)/version.Revision=$(REV)\
+  " -X $(METAPKG)/version.Version=$(DEB_VERSION_UPSTREAM)\
+    -X $(METAPKG)/version.Revision=$(DEB_VERSION)\
     -X $(METAPKG)/version.Branch=$(BRANCH)\
     -X $(METAPKG)/version.BuildUser=$(USER)\
     -X $(METAPKG)/version.BuildDate=$(BUILD_DATE)\
@@ -61,13 +57,15 @@
 	dh_auto_build -- $(BUILDFLAGS)
 
 override_dh_auto_test:
+	$(CURDIR)/ttar -C $(BUILDDIR)/src/$(DH_GOPKG)/collector/fixtures \
+            -x -f collector/fixtures/sys.ttar
 	chmod a+x $(BUILDDIR)/src/$(DH_GOPKG)/collector/fixtures/megacli
 	dh_auto_test -- $(BUILDFLAGS)
 
 override_dh_auto_install:
-	mkdir -p debian/$(DEBPKGNAME)/usr/bin
+	mkdir -p debian/$(DEB_SOURCE)/usr/bin
 	# Rename the binary to match the debian package.
 	cp -v $(BUILDDIR)/bin/node_exporter \
-            debian/$(DEBPKGNAME)/usr/bin/$(DEBPKGNAME)
+            debian/$(DEB_SOURCE)/usr/bin/$(DEB_SOURCE)
 	cp -v debian/README.textfile \
-            debian/$(DEBPKGNAME)/var/lib/prometheus/node-exporter
+            debian/$(DEB_SOURCE)/var/lib/prometheus/node-exporter

=== debian/watch ===
version=3

opts="filenamemangle=s/(?:.*\/)?v?(\d[\d\.]*)\.tar\.gz/prometheus-node-exporter-$1.tar.gz/,dversionmangle=s/\+ds.*$//,uversionmangle=s/-?(rc\.?\d+)/~$1/" \
         https://github.com/prometheus/node_exporter/tags \
         (?:.*/)?v?(\d[\d\.]*(?:-?rc\.?\d+)?)\.tar\.gz

## prometheus-node-exporter 0.16.0+ds

=== Makefile ===
--- 
+++ 
@@ -16,6 +16,7 @@
 GOARCH := $(shell $(GO) env GOARCH)
 GOHOSTARCH := $(shell $(GO) env GOHOSTARCH)
 
+PROMTOOL    ?= $(GOPATH)/bin/promtool
 PROMU       ?= $(GOPATH)/bin/promu
 STATICCHECK ?= $(GOPATH)/bin/staticcheck
 pkgs         = $(shell $(GO) list ./... | grep -v /vendor/)
@@ -27,10 +28,7 @@
 MACH                    ?= $(shell uname -m)
 DOCKERFILE              ?= Dockerfile
 
-ifeq ($(GOHOSTARCH),amd64)
-	# Only supported on amd64
-	test-flags := -race
-endif
+STATICCHECK_IGNORE =
 
 ifeq ($(OS),Windows_NT)
     OS_detected := Windows
@@ -38,10 +36,25 @@
     OS_detected := $(shell uname -s)
 endif
 
+ifeq ($(GOHOSTARCH),amd64)
+	ifeq ($(OS_detected),$(filter $(OS_detected),Linux FreeBSD Darwin Windows))
+                # Only supported on amd64
+                test-flags := -race
+        endif
+endif
+
 ifeq ($(OS_detected), Linux)
     test-e2e := test-e2e
 else
     test-e2e := skip-test-e2e
+endif
+
+e2e-out = collector/fixtures/e2e-output.txt
+ifeq ($(MACH), ppc64le)
+	e2e-out = collector/fixtures/e2e-64k-page-output.txt
+endif
+ifeq ($(MACH), aarch64)
+	e2e-out = collector/fixtures/e2e-64k-page-output.txt
 endif
 
 # 64bit -> 32bit mapping for cross-checking. At least for amd64/386, the 64bit CPU can execute 32bit code but not the other way around, so we don't support cross-testing upwards.
@@ -57,11 +70,10 @@
 
 # By default, "cross" test with ourselves to cover unknown pairings.
 $(eval $(call goarch_pair,amd64,386))
-$(eval $(call goarch_pair,arm64,arm))
 $(eval $(call goarch_pair,mips64,mips))
 $(eval $(call goarch_pair,mips64el,mipsel))
 
-all: format vet staticcheck build test $(cross-test) $(test-e2e)
+all: style vet staticcheck checkmetrics build test $(cross-test) $(test-e2e)
 
 style:
 	@echo ">> checking code style"
@@ -79,6 +91,8 @@
 	@echo ">> SKIP running tests in 32-bit mode: not supported on $(OS_detected)/$(GOARCH)"
 
 collector/fixtures/sys/.unpacked: collector/fixtures/sys.ttar
+	@echo ">> extracting sysfs fixtures"
+	if [ -d collector/fixtures/sys ] ; then rm -r collector/fixtures/sys ; fi
 	./ttar -C collector/fixtures -x -f collector/fixtures/sys.ttar
 	touch $@
 
@@ -88,6 +102,10 @@
 
 skip-test-e2e:
 	@echo ">> SKIP running end-to-end tests on $(OS_detected)"
+
+checkmetrics: $(PROMTOOL)
+	@echo ">> checking metrics for correctness"
+	./checkmetrics.sh $(PROMTOOL) $(e2e-out)
 
 format:
 	@echo ">> formatting code"
@@ -99,7 +117,7 @@
 
 staticcheck: $(STATICCHECK)
 	@echo ">> running staticcheck"
-	@$(STATICCHECK) $(pkgs)
+	@$(STATICCHECK) -ignore "$(STATICCHECK_IGNORE)" $(pkgs)
 
 build: $(PROMU)
 	@echo ">> building binaries"
@@ -120,6 +138,9 @@
 	@echo ">> testing docker image"
 	./test_image.sh "$(DOCKER_IMAGE_NAME):$(DOCKER_IMAGE_TAG)" 9100
 
+$(GOPATH)/bin/promtool promtool:
+	@GOOS= GOARCH= $(GO) get -u github.com/prometheus/prometheus/cmd/promtool
+
 $(GOPATH)/bin/promu promu:
 	@GOOS= GOARCH= $(GO) get -u github.com/prometheus/promu
 
@@ -127,10 +148,10 @@
 	@GOOS= GOARCH= $(GO) get -u honnef.co/go/tools/cmd/staticcheck
 
 
-.PHONY: all style format build test test-e2e vet tarball docker promu staticcheck
+.PHONY: all style format build test test-e2e vet tarball docker promtool promu staticcheck checkmetrics
 
 # Declaring the binaries at their default locations as PHONY targets is a hack
 # to ensure the latest version is downloaded on every make execution.
 # If this is not desired, copy/symlink these binaries to a different path and
 # set the respective environment variables.
-.PHONY: $(GOPATH)/bin/promu $(GOPATH)/bin/staticcheck
+.PHONY: $(GOPATH)/bin/promtool $(GOPATH)/bin/promu $(GOPATH)/bin/staticcheck

=== debian/changelog ===
prometheus-node-exporter (0.16.0+ds-1) unstable; urgency=medium

  [ Alexandre Viau ]
  * Point Vcs-* urls to salsa.debian.org.

  [ Michael Stapelberg ]
  * gbp.conf: set debian-branch

  [ Martín Ferrari ]
  * New upstream release. Closes: #900760.
  * Refresh patches.
  * Fix dependency version of x/sys (missing SOL_NETLINK).
  * Instead of putting arguments in the default /etc/default file, set
    them in the source. Closes: #886891.
  * debian/NEWS: Announce beaking changes.
  * debian/rules: Automatically generate man page.
  * debian/rules: Remove reference to nonexistent fixture.
  * debian/control: Depend on latest version of procfs.
  * debian/default: Update available flags.
  * debian/copyright: Add repackaging comment.
  * debian/copyright: Add missing ttar attribution.
  * debian/postinst: Stop changing permissions recursively.
  * debian/docs: Add missing documentation.
  * Update dh compat level to 11.
  * Bump Standards-Version (no changes).
  * debian/rules: Remove now unneeded workarounds.

 -- Martín Ferrari <tincho@debian.org>  Wed, 13 Jun 2018 19:00:23 +0000

=== debian/control ===
--- 
+++ 
@@ -4,7 +4,7 @@
 Section: net
 Testsuite: autopkgtest-pkg-go
 Priority: optional
-Build-Depends: debhelper (>= 10),
+Build-Depends: debhelper (>= 11),
                dh-golang (>= 1.17~),
                golang-any,
                golang-dbus-dev,
@@ -13,13 +13,13 @@
                golang-github-prometheus-client-golang-dev,
                golang-github-prometheus-client-model-dev,
                golang-github-prometheus-common-dev (>= 0+git20171117),
-               golang-golang-x-sys-dev,
+               golang-golang-x-sys-dev (>= 0.0~git20170630),
                golang-gopkg-alecthomas-kingpin.v2-dev,
                golang-goprotobuf-dev,
-               golang-procfs-dev (>= 0+git20170703),
-Standards-Version: 4.1.2
-Vcs-Browser: https://anonscm.debian.org/cgit/pkg-go/packages/prometheus-node-exporter.git
-Vcs-Git: https://anonscm.debian.org/git/pkg-go/packages/prometheus-node-exporter.git
+               golang-procfs-dev (>= 0+git20180613),
+Standards-Version: 4.1.4
+Vcs-Browser: https://salsa.debian.org/go-team/packages/prometheus-node-exporter
+Vcs-Git: https://salsa.debian.org/go-team/packages/prometheus-node-exporter.git
 Homepage: https://github.com/prometheus/node_exporter
 XS-Go-Import-Path: github.com/prometheus/node_exporter

=== debian/rules ===
#!/usr/bin/make -f
include /usr/share/dpkg/pkg-info.mk

export DH_VERBOSE=1
export DH_GOPKG := github.com/prometheus/node_exporter
export DH_GOLANG_INSTALL_EXTRA := collector/fixtures

BUILDDIR := $(CURDIR)/build
METAPKG := github.com/prometheus/common

BRANCH     := debian/sid
USER       := pkg-go-maintainers@lists.alioth.debian.org
BUILD_DATE := $(shell date --utc --date='@$(SOURCE_DATE_EPOCH)' \
    +%Y%m%d-%H:%M:%S)
GO_VERSION := $(shell go version | sed 's/go version \(\S*\).*/\1/')
BUILDTAGS  :=
BUILDFLAGS  = -tags "$(BUILDTAGS)" -ldflags \
  " -X $(METAPKG)/version.Version=$(DEB_VERSION_UPSTREAM)\
    -X $(METAPKG)/version.Revision=$(DEB_VERSION)\
    -X $(METAPKG)/version.Branch=$(BRANCH)\
    -X $(METAPKG)/version.BuildUser=$(USER)\
    -X $(METAPKG)/version.BuildDate=$(BUILD_DATE)\
    -X $(METAPKG)/version.GoVersion=$(GO_VERSION)"

%:
	dh $@ --buildsystem=golang --with=golang \
            --builddirectory=$(BUILDDIR)

# ZFS (or its tests) are not working in 32-bit arches.
DEB_HOST_ARCH_BITS := $(shell dpkg-architecture -qDEB_HOST_ARCH_BITS)
ifeq ($(DEB_HOST_ARCH_BITS),32)
BUILDTAGS += nozfs
endif

BINNAME := $(DEB_SOURCE)
WHATIS := "$(BINNAME) \\- Prometheus exporter for machine metrics"

override_dh_auto_build:
	dh_auto_build -- $(BUILDFLAGS)
	# Rename the binary to match the debian package.
	cp -v $(BUILDDIR)/bin/node_exporter $(BUILDDIR)/bin/$(BINNAME)
	build/bin/$(BINNAME) --help-man > build/$(BINNAME).1
	# Remove build user/build date/go version headers, which is ugly.
	sed -i -e '/^  /d' build/$(BINNAME).1
	# Fix whatis entry.
	sed -i '/^.SH "NAME"/,+1c.SH "NAME"\n'$(WHATIS) build/$(BINNAME).1
	# Remove default values as they create unwieldy long lines.
	sed -i 's/\\fB--\(.*\)=".*"\\fR/\\fB--\1\\fR/' build/$(BINNAME).1

override_dh_auto_test:
	$(CURDIR)/ttar -C $(BUILDDIR)/src/$(DH_GOPKG)/collector/fixtures \
            -x -f collector/fixtures/sys.ttar
	dh_auto_test -- $(BUILDFLAGS)

override_dh_auto_install:

## prometheus-node-exporter 0.17.0+ds

=== Makefile ===
# Copyright 2015 The Prometheus Authors
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
# http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

include Makefile.common

GO     ?= GO15VENDOREXPERIMENT=1 go
GOARCH := $(shell $(GO) env GOARCH)
GOHOSTARCH := $(shell $(GO) env GOHOSTARCH)

PROMTOOL_VERSION ?= 2.5.0
PROMTOOL_URL     ?= https://github.com/prometheus/prometheus/releases/download/v$(PROMTOOL_VERSION)/prometheus-$(PROMTOOL_VERSION).$(GO_BUILD_PLATFORM).tar.gz
PROMTOOL         ?= $(FIRST_GOPATH)/bin/promtool

DOCKER_IMAGE_NAME       ?= node-exporter
MACH                    ?= $(shell uname -m)
DOCKERFILE              ?= Dockerfile

STATICCHECK_IGNORE =

ifeq ($(OS),Windows_NT)
	OS_detected := Windows
else
	OS_detected := $(shell uname -s)
endif

ifeq ($(GOHOSTARCH),amd64)
	ifeq ($(OS_detected),$(filter $(OS_detected),Linux FreeBSD Darwin Windows))
		# Only supported on amd64
		test-flags := -race
	endif
endif

ifeq ($(OS_detected), Linux)
	test-e2e := test-e2e
else
	test-e2e := skip-test-e2e
endif

# Use CGO for non-Linux builds.
ifeq ($(GOOS), linux)
	PROMU_CONF ?= .promu.yml
else
	ifndef GOOS
		ifeq ($(OS_detected), Linux)
			PROMU_CONF ?= .promu.yml
		else
			PROMU_CONF ?= .promu-cgo.yml
		endif
	else
		PROMU_CONF ?= .promu-cgo.yml
	endif
endif

PROMU := $(FIRST_GOPATH)/bin/promu --config $(PROMU_CONF)

e2e-out = collector/fixtures/e2e-output.txt
ifeq ($(MACH), ppc64le)
	e2e-out = collector/fixtures/e2e-64k-page-output.txt
endif
ifeq ($(MACH), aarch64)
	e2e-out = collector/fixtures/e2e-64k-page-output.txt
endif

# 64bit -> 32bit mapping for cross-checking. At least for amd64/386, the 64bit CPU can execute 32bit code but not the other way around, so we don't support cross-testing upwards.
cross-test = skip-test-32bit
define goarch_pair
	ifeq ($$(OS_detected),Linux)
		ifeq ($$(GOARCH),$1)
			GOARCH_CROSS = $2
			cross-test = test-32bit
		endif
	endif
endef

# By default, "cross" test with ourselves to cover unknown pairings.
$(eval $(call goarch_pair,amd64,386))
$(eval $(call goarch_pair,mips64,mips))
$(eval $(call goarch_pair,mips64el,mipsel))

all: style vet staticcheck checkmetrics checkrules build test $(cross-test) $(test-e2e)

.PHONY: test
test: collector/fixtures/sys/.unpacked
	@echo ">> running tests"
	$(GO) test -short $(test-flags) $(pkgs)

.PHONY: test-32bit
test-32bit: collector/fixtures/sys/.unpacked
	@echo ">> running tests in 32-bit mode"
	@env GOARCH=$(GOARCH_CROSS) $(GO) test $(pkgs)

.PHONY: skip-test-32bit
skip-test-32bit:
	@echo ">> SKIP running tests in 32-bit mode: not supported on $(OS_detected)/$(GOARCH)"

collector/fixtures/sys/.unpacked: collector/fixtures/sys.ttar
	@echo ">> extracting sysfs fixtures"
	if [ -d collector/fixtures/sys ] ; then rm -r collector/fixtures/sys ; fi
	./ttar -C collector/fixtures -x -f collector/fixtures/sys.ttar
	touch $@

.PHONY: test-e2e
test-e2e: build collector/fixtures/sys/.unpacked
	@echo ">> running end-to-end tests"
	./end-to-end-test.sh

.PHONY: skip-test-e2e
skip-test-e2e:
	@echo ">> SKIP running end-to-end tests on $(OS_detected)"

.PHONY: checkmetrics
checkmetrics: $(PROMTOOL)
	@echo ">> checking metrics for correctness"
	./checkmetrics.sh $(PROMTOOL) $(e2e-out)

.PHONY: checkrules
checkrules: $(PROMTOOL)
	@echo ">> checking rules for correctness"
	find . -name "*rules*.yml" | xargs -I {} $(PROMTOOL) check rules {}

.PHONY: docker
docker:
ifeq ($(MACH), ppc64le)
	$(eval DOCKERFILE=Dockerfile.ppc64le)
endif
	@echo ">> building docker image from $(DOCKERFILE)"
	@docker build --file $(DOCKERFILE) -t "$(DOCKER_REPO)/$(DOCKER_IMAGE_NAME):$(DOCKER_IMAGE_TAG)" .

.PHONY: test-docker
test-docker:
	@echo ">> testing docker image"
	./test_image.sh "$(DOCKER_REPO)/$(DOCKER_IMAGE_NAME):$(DOCKER_IMAGE_TAG)" 9100

.PHONY: promtool
promtool: $(PROMTOOL)

.PHONY: $(PROMTOOL)
$(PROMTOOL):
	$(eval PROMTOOL_TMP := $(shell mktemp -d))
	curl -s -L $(PROMTOOL_URL) | tar -xvzf - -C $(PROMTOOL_TMP)
	mkdir -p $(FIRST_GOPATH)/bin
	cp $(PROMTOOL_TMP)/prometheus-$(PROMTOOL_VERSION).$(GO_BUILD_PLATFORM)/promtool $(FIRST_GOPATH)/bin/promtool
	rm -r $(PROMTOOL_TMP)

=== debian/changelog ===
prometheus-node-exporter (0.17.0+ds-3) unstable; urgency=medium

  [ Benjamin Drung ]
  * Team upload
  * Ship a systemd service for the mellanox_hca_temp collector
  * Ship a systemd service for the ipmitool sensor collector
  * Drop python from Recommends (All text collector script use Python 3 now)
  * Bump Standards-Version to 4.3.0 (no changes required)

  [ Martín Ferrari ]
  * Set TMPDIR so textfiles are created atomically. Closes: #920827.
  * Recommend dbus, as the systemd collector does not work without it.

 -- Benjamin Drung <benjamin.drung@cloud.ionos.com>  Thu, 31 Jan 2019 18:33:42 +0100

prometheus-node-exporter (0.17.0+ds-2) unstable; urgency=medium

  * Use alternative solution for #916236, cherry-picked from upstream;
    thanks to Andre Heider for the patch.

 -- Martín Ferrari <tincho@debian.org>  Fri, 14 Dec 2018 14:09:27 +0000

prometheus-node-exporter (0.17.0+ds-1) unstable; urgency=medium

  [ Philipp Kern ]
  * Ship a systemd service for the apt text collector. apt is checked for
    pending reboots and updated packages every 15 minutes.

  [ Martín Ferrari ]
  * New upstream release.
  * Refresh patches.
  * Update procfs dependency.
  * Avoid waking up disks unnecessarily. Closes: #916055

 -- Martín Ferrari <tincho@debian.org>  Thu, 13 Dec 2018 23:39:17 +0000

prometheus-node-exporter (0.16.0+ds-2) unstable; urgency=medium

  [ Philipp Kern ]
  * Add a stricter dependency on golang-github-prometheus-client-golang-
    dev.
  * Ship the YAML-based example rules instead of the old-style ones.
  * Install the text collector examples as scripts into /usr/share/$pkg.
    Closes: #910865
  * Ship a systemd service for the smartmon text collector. smartmon is
    invoked using a systemd timer every 15 minutes, if smartmontools is
    installed.
  * Enable the systemd collector by default.
  * Blacklist devices, slices, and targets by default in systemd
    collector.

  [ Martín Ferrari ]
  * Ignore /mnt and /media by default. Closes: #908811
  * debian/default: Update flag documentation.
  * debian/control: Add python and python3 to Recommends, for collector
    scripts.
  * debian/rules: Check DEB_BUILD_OPTIONS before running tests.
  * Update Standards-Version with no changes.

 -- Martín Ferrari <tincho@debian.org>  Mon, 15 Oct 2018 16:25:37 +0000

=== debian/control ===
--- 
+++ 
@@ -10,14 +10,14 @@
                golang-dbus-dev,
                golang-github-coreos-go-systemd-dev,
                golang-github-kolo-xmlrpc-dev,
-               golang-github-prometheus-client-golang-dev,
+               golang-github-prometheus-client-golang-dev (>= 0.9.0~pre1+git20180417),
                golang-github-prometheus-client-model-dev,
                golang-github-prometheus-common-dev (>= 0+git20171117),
                golang-golang-x-sys-dev (>= 0.0~git20170630),
                golang-gopkg-alecthomas-kingpin.v2-dev,
                golang-goprotobuf-dev,
-               golang-procfs-dev (>= 0+git20180613),
-Standards-Version: 4.1.4
+               golang-procfs-dev (>= 0+git20181004),
+Standards-Version: 4.3.0
 Vcs-Browser: https://salsa.debian.org/go-team/packages/prometheus-node-exporter
 Vcs-Git: https://salsa.debian.org/go-team/packages/prometheus-node-exporter.git
 Homepage: https://github.com/prometheus/node_exporter
@@ -26,8 +26,12 @@
 Package: prometheus-node-exporter
 Architecture: any
 Depends: daemon | systemd-sysv,
+         moreutils,
          ${misc:Depends},
          ${shlibs:Depends},
+Recommends: dbus,
+            python3,
+            smartmontools,
 Built-Using: ${misc:Built-Using},
 Description: Prometheus exporter for machine metrics
  Prometheus exporter for machine metrics, written in Go with pluggable metric

=== debian/rules ===
--- 
+++ 
@@ -48,8 +48,31 @@
 	sed -i 's/\\fB--\(.*\)=".*"\\fR/\\fB--\1\\fR/' build/$(BINNAME).1
 
 override_dh_auto_test:
+ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
 	$(CURDIR)/ttar -C $(BUILDDIR)/src/$(DH_GOPKG)/collector/fixtures \
             -x -f collector/fixtures/sys.ttar
 	dh_auto_test -- $(BUILDFLAGS)
+endif
+
+override_dh_installsystemd:
+	dh_installsystemd
+	dh_installsystemd --name=prometheus-node-exporter-smartmon \
+		prometheus-node-exporter-smartmon.timer
+	dh_installsystemd --name==prometheus-node-exporter-smartmon \
+		--no-start \
+		prometheus-node-exporter-smartmon.service
+	dh_installsystemd --name=prometheus-node-exporter-apt \
+		prometheus-node-exporter-apt.timer
+	dh_installsystemd --name=prometheus-node-exporter-apt \
+		--no-start \
+		prometheus-node-exporter-apt.service
+	dh_installsystemd --name=prometheus-node-exporter-ipmitool-sensor \
+		prometheus-node-exporter-ipmitool-sensor.timer
+	dh_installsystemd --name=prometheus-node-exporter-ipmitool-sensor \
+		--no-start prometheus-node-exporter-ipmitool-sensor.service
+	dh_installsystemd --name=prometheus-node-exporter-mellanox-hca-temp \
+		prometheus-node-exporter-mellanox-hca-temp.timer
+	dh_installsystemd --name=prometheus-node-exporter-mellanox-hca-temp \
+		--no-start prometheus-node-exporter-mellanox-hca-temp.service
 
 override_dh_auto_install:
